package org.processmining.primeminer.dialogs;

import java.awt.Dimension;
import java.awt.Font;
import java.util.ArrayList;

import javax.swing.JLabel;
import javax.swing.JList;
import javax.swing.JPanel;
import javax.swing.JScrollPane;
import javax.swing.JSlider;
import javax.swing.JTextArea;
import javax.swing.ListSelectionModel;
import javax.swing.event.ChangeEvent;
import javax.swing.event.ChangeListener;

import org.processmining.contexts.uitopia.UIPluginContext;

import info.clearthought.layout.TableLayout;
import info.clearthought.layout.TableLayoutConstants;

public class YourDialog extends JPanel
{

	/**
	 * 
	 */
	private static final long serialVersionUID = -60087716353524468L;

	public int sliderValue;
	public JList<String> list;
			
	/**
	 * The JPanel that allows the user to set (a subset of) the parameters.
	 */
	
	public YourDialog(UIPluginContext context, String dialog) 
	{
		double size[][] = { { TableLayoutConstants.FILL }, { TableLayoutConstants.FILL,60} };
		setLayout(new TableLayout(size));
		
		JScrollPane scroll;
		
		JTextArea text = new JTextArea(16,100);
		scroll = new JScrollPane(text);
		
		text.setSize(300, 5);
		text.setFont(new Font("Courier New", Font.PLAIN, 14));
		text.setText(dialog);
		add(scroll,"0, 0");
		scroll.getVerticalScrollBar().setValue(scroll.getVerticalScrollBar().getMaximum());
		
		
		JLabel lable = new JLabel("Show the resulting Nets.");
		lable.setFont(new Font("Courier New", Font.PLAIN, 14));
		add(lable,"0, 1");
		
	}
	
	public YourDialog(UIPluginContext context, String dialog, ArrayList<String> oracleChoice) 
	{
		double size[][] = { { TableLayoutConstants.FILL }, { TableLayoutConstants.FILL, 60, 60 } };
		setLayout(new TableLayout(size));
		
		JScrollPane scroll;
		
		JTextArea text = new JTextArea(6,100);
		scroll = new JScrollPane(text);
		
		text.setSize(300, 5);
		text.setFont(new Font("Courier New", Font.PLAIN, 14));
		text.setText(dialog);
		add(scroll,"0, 0");
		
		JLabel lable = new JLabel("Please select a concurrency oracle.");
		lable.setFont(new Font("Courier New", Font.PLAIN, 14));
		add(lable,"0, 1");
		
		String[] choices= new String[oracleChoice.size()];
		for (String value: oracleChoice) choices[oracleChoice.indexOf(value)]=value;
		list = new JList<String>(choices);
		list.setSelectionMode(ListSelectionModel.SINGLE_INTERVAL_SELECTION);
		list.setLayoutOrientation(JList.VERTICAL);
		list.setVisibleRowCount(oracleChoice.size()-1);
		list.setSelectedIndex(0);
		list.setPreferredSize(new Dimension(2, 100));
		add(list, "0, 2");
		
	}
		
	public YourDialog(UIPluginContext context, String dialog, int partialLanguageSize) 
	{
		sliderValue = partialLanguageSize;
		
		//double size[][] = { { TableLayoutConstants.FILL }, { TableLayoutConstants.FILL, 60, 60 } };
		double size[][] = { { TableLayoutConstants.FILL }, { TableLayoutConstants.FILL, 60, 60, 40} };
		setLayout(new TableLayout(size));
		
		JScrollPane scroll;
		
		JTextArea text = new JTextArea(10,100);
		scroll = new JScrollPane(text);
		text.setFont(new Font("Courier New", Font.PLAIN, 14));
		text.setText(dialog);
		add(scroll,"0, 0");
			
		JLabel lable = new JLabel("Please select the number of Hasse diagrams you like to consider.");
		lable.setFont(new Font("Courier New", Font.PLAIN, 14));
		add(lable,"0, 1");
		
		final JSlider integerSilder = new JSlider(JSlider.HORIZONTAL,1,partialLanguageSize,partialLanguageSize);
		integerSilder.setFont(new Font("Courier New", Font.PLAIN, 14));
		integerSilder.setMajorTickSpacing(1);
		integerSilder.setMinorTickSpacing(1);
		integerSilder.setPaintTicks(true);
		integerSilder.setPaintLabels(true);
		integerSilder.addChangeListener(new ChangeListener() {
			public void stateChanged(ChangeEvent e) {
				sliderValue = integerSilder.getValue();
			}
		});
		add(integerSilder, "0, 2");
		
		String[] choices = new String[]{"Show Hasse diagrams.","Mine Petri net models."};
		list = new JList<String>(choices);
		list.setSelectionMode(ListSelectionModel.SINGLE_INTERVAL_SELECTION);
		list.setLayoutOrientation(JList.VERTICAL);
		list.setFont(new Font("Courier New", Font.PLAIN, 14));
		list.setVisibleRowCount(1);
		list.setSelectedIndex(1);
		list.setPreferredSize(new Dimension(100, 100));
		add(list, "0, 3");
	}
}
